<template>
	<div class="bg-white w-full md:w-690 lg:w-722 px-4 pt-8 pb-16 md:p-6 lg:p-14">
		<div class="flex flex-row justify-between items-center">
			<h2 class="font-secondary-font-regular text-xl md:text-2xl lg:text-base2 leading-6 md:leading-7 lg:leading-10">
				{{ editButton ? 'Profile' : 'Edit profile' }}
			</h2>
			<div
				v-if="editButton"
				ref="profile_edit"
				tabindex="0"
				role="button"
				class="focus:ring-1 focus:ring-black"
				@keydown.enter="editProfile()"
				@click="editProfile()"
			>
				<img src="~/assets/images/edit-icon.svg" alt="Profile Edit" class="w-5 md:w-5" />
			</div>
		</div>
		<div v-if="editButton" class="mt-6 lg:mt-10">
			<div class="grid grid-flow-col grid-cols-12 mb-6 md:mb-5 lg:mb-6">
				<p
					class="font-primary-font-bold text-base lg:text-base leading-6 md:leading-4 lg:leading-6 col-span-4 md:col-span-2 lg:col-span-4"
				>
					Name
				</p>
				<p
					class="font-primary-font-light text-base md:text-sm lg:text-base leading-6 md:leading-4 lg:leading-6 col-span-4 md:col-span-2 lg:col-span-3"
				>
					{{ profileInformation.firstName }} {{ profileInformation.lastName }}
				</p>
			</div>
			<div class="grid grid-flow-col grid-cols-12 mb-6 md:mb-5 lg:mb-6">
				<p
					class="font-primary-font-bold text-base lg:text-base leading-6 md:leading-4 lg:leading-6 col-span-4 md:col-span-2 lg:col-span-4"
				>
					Email
				</p>
				<p
					class="font-primary-font-light text-base md:text-sm lg:text-base leading-6 md:leading-4 lg:leading-6 col-span-4 md:col-span-2 lg:col-span-3"
				>
					{{ profileInformation.email }}
				</p>
			</div>
			<div class="grid grid-flow-col grid-cols-12">
				<p
					class="font-primary-font-bold text-base lg:text-base leading-6 md:leading-4 lg:leading-6 col-span-4 md:col-span-2 lg:col-span-4"
				>
					Password
				</p>
				<p
					class="font-primary-font-light text-base md:text-sm lg:text-base leading-6 md:leading-4 lg:leading-6 col-span-4 md:col-span-2 lg:col-span-3"
				>
					••••••••
				</p>
			</div>
		</div>
		<div v-else class="mt-6 lg:mt-10">
			<ValidationObserver ref="update_details_validation_observer">
				<div>
					<MkInput
						id="profile_first_name"
						v-model="profileInformation['firstName']"
						:set-focus="setFocus"
						class="mb-4 cursor-pointer tw-input"
						rules="required|alpha_spaces"
						variant="outline"
						label="First name"
					/>
				</div>
				<div class="mt-6">
					<MkInput
						id="profile_last_name"
						v-model="profileInformation['lastName']"
						class="mb-4"
						rules="required|alpha_spaces"
						variant="outline"
						label="Last name"
					/>
				</div>
				<div role="radiogroup" aria-labelledby="Check_label" class="mt-8 md:mt-6 lg:mt-8 flex flex-col md:flex-row">
					<div class="flex items-center">
						<MkCheck
							id="email_check_label"
							:checked="changeEmail"
							radio-title="Change email"
							role-type="radio"
							check-type="radio"
							@change="changeContent"
						/>
					</div>
					<div class="flex items-center mt-8 md:mt-0 ml-0 md:ml-16 lg:ml-28">
						<MkCheck
							id="password_check_label"
							:checked="changePassword"
							radio-title="Change password"
							role-type="radio"
							check-type="radio"
							@change="changePasswordContent"
						/>
					</div>
				</div>
				<div class="mt-8">
					<MkInput
						v-if="changeEmail"
						id="profile_email"
						v-model="profileInformation['email']"
						class="mb-4"
						rules="required|email"
						variant="outline"
						label="Email"
					/>
					<MkInput
						v-if="changeEmail"
						id="profile_password"
						v-model="changeEmailObj.password"
						class="mb-4 mt-6"
						type="password"
						:value="profileInformation['password']"
						rules="required"
						variant="outline"
						label="Password"
					/>
					<MkInput
						v-if="changePassword"
						id="previous_password"
						v-model="changePasswordObj.previousPassword"
						class="mb-4"
						type="password"
						rules="required"
						variant="outline"
						label="Current password"
						vid="previous_password"
					/>
					<a
						v-if="changePassword || changeEmail"
						href="/D2C/login/passwordReset"
						class="font-primary-font-bold text-base flex leading-6 mt-10 md:mt-6 lg:mt-8 mk-link"
						>I forgot my password</a
					>
					<div v-if="changePassword" class="mt-8">
						<div class="relative">
							<MkInput
								v-model="changePasswordObj.proposedPassword"
								label="Create new password"
								type="password"
								class="mb-4"
								placeholder=" "
								rules="required|valid_password"
								variant="outline"
								:vid="'profile_password_vid'"
							/>
							<div
								class="inline-block absolute right-0 top-0 transform translate-y-4 md:translate-y-3 group p-0.5 pt-0 mk-tooltip"
								role="tooltip"
								tabindex="0"
							>
								<span class="icon-notification text-base" aria-label="Password suggestion icon Tooltip"></span>
								<MkCartTooltip class="hidden group-hover:block" :rotate-left="true" :icon-position="toolTipPosition">
									<template #tooltipRightValue>
										<p>8 character min.</p>
										<p>1 lowercase letter</p>
										<p>1 uppercase letter</p>
										<p>1 number</p>
										<p>1 special character</p>
									</template>
								</MkCartTooltip>
							</div>
						</div>
						<div class="mt-6">
							<MkInput
								v-model="changePasswordObj.confirmPassword"
								label="Confirm new password"
								type="password"
								class="mb-4"
								placeholder=" "
								rules="required|confirmed:profile_password_vid"
								variant="outline"
							/>
						</div>
					</div>
				</div>
				<div
					v-if="isEurope"
					role="radiogroup"
					aria-labelledby="Check_label"
					class="mt-8 md:mt-6 lg:mt-8 flex md:flex-row"
				>
					<MkCheck
						:checked="enableMarketing"
						class="mb-4"
						aria-label="Receive product news & exclusive offers. You can unsubscribe at any time - please see our privacy policy for details."
						@change="changeMarketing"
					/>
					<span>
						<span class="font-primary-font-light"
							>Receive product news & exclusive offers. You can unsubscribe at any time - please see our</span
						>
						<strong>
							<nuxt-link class="mk-link" to="/legal#privacy" target="_blank"> privacy policy </nuxt-link>
						</strong>
						<span class="font-primary-font-light"> for details.</span>
					</span>
				</div>
			</ValidationObserver>
			<div class="mt-6 md:mt-8 lg:mt-10 flex flex-col justify-center items-center">
				<MkPrimaryButton
					class="font-primary-font-regular text-base md:text-xl lg:text-base leading-6 min-w-150"
					:loading="loading"
					aria-labelledby="change_password_success_message"
					button-title="Save"
					font-size="text-xl"
					:disable="true"
					@click="updateDetails()"
				/>

				<span
					id="change_password_success_message"
					ref="change_password_success_message"
					aria-hidden="true"
					role="alert"
					aria-live="polite"
					class="sr-only display:none"
				></span>

				<span
					role="button"
					tabindex="0"
					class="mt-8 md:mt-6 lg:mt-8 font-primary-font-light md:font-primary-font-bold text-base leading-6 mk-link cursor-pointer focus:outline-none focus:ring-1 focus:ring-black"
					@click="editProfile()"
					@keydown.enter="editProfile()"
					@keydown="backToInput($event)"
					>Cancel</span
				>
			</div>
		</div>
	</div>
</template>
<script>
import { mapState } from 'vuex';
import { ValidationObserver } from 'vee-validate';
import MkInput from '~/components/D2C/atoms/MkInput.vue';
import MkCheck from '~/components/D2C/atoms/MkCheck.vue';
import MkPrimaryButton from '~/components/D2C/atoms/MkPrimaryButton.vue';
import MkCartTooltip from '~/components/D2C/atoms/MkCartTooltip.vue';
export default {
	components: {
		MkInput,
		MkCheck,
		MkPrimaryButton,
		MkCartTooltip,
		ValidationObserver,
	},
	layout: 'aurora-layout',
	props: {
		setFocus: {
			type: String,
			default: 'true',
		},
	},
	data() {
		return {
			changePasswordSuccessText: '',
			profileInformation: {
				email: '',
				firstName: '',
				lastName: '',
				password: '',
				emails: '',
			},
			toolTipPosition: null,
			changeEmail: false,
			changePassword: false,
			editButton: true,
			emailChange: false,
			passwordChange: false,
			loading: false,
			changePasswordObj: {},
			changeEmailObj: {},
			enableMarketing: false,
		};
	},
	head() {
		return {
			title: 'Profile',
		};
	},
	computed: {
		profileData() {
			return this.$store.state.USER_STORE.CUSTOMER_PROFILE;
		},
		accessToken() {
			return this.$store.state.USER_STORE.ACCESS_TOKEN;
		},
		...mapState('USER_STORE', ['AUTHENTICATED']),
		...mapState(['isEurope']),
	},
	watch: {
		AUTHENTICATED() {
			if (this.AUTHENTICATED) {
				this.getProfile();
			}
		},
	},
	mounted() {
		if (this.AUTHENTICATED) {
			this.getProfile();
		}
	},
	methods: {
		async getProfile() {
			this.$store.commit('CHECKOUT_STORE/TOGGLE_PAGE_SPINNER');
			await this.$store.dispatch('USER_STORE/GET_PROFILE');
			this.setProfile();
			this.$store.commit('CHECKOUT_STORE/TOGGLE_PAGE_SPINNER');
		},
		setProfile() {
			const { id, firstName, lastName, email, password, custom } = this.profileData;
			this.profileInformation = {
				id,
				firstName,
				lastName,
				email,
				password,
			};
			this.enableMarketing = custom?.fields?.marketingOffers;
		},
		changeContent() {
			this.changeEmail = !this.changeEmail;
			this.changePassword = this.changeEmail ? false : this.changePassword;
			this.$forceUpdate();
		},
		changePasswordContent() {
			this.changePassword = !this.changePassword;
			this.changeEmail = this.changePassword ? false : this.changeEmail;
			this.$forceUpdate();
		},
		changeMarketing() {
			this.enableMarketing = !this.enableMarketing;
		},
		editProfile() {
			this.editButton = !this.editButton;
			this.setProfile();
			this.$root.$utility.elementFocus(this, 'profile_edit');
		},
		async updateDetails() {
			const valid = await this.$refs.update_details_validation_observer.validate();
			if (!valid) {
				return;
			}
			this.loading = true;
			try {
				let result = '';
				let msg = '';
				if (this.changeEmail) {
					this.changeEmailObj.email = this.profileInformation.email;
					this.changeEmailObj.action = 'UPDATE_EMAIL';
					this.changeEmailObj.countryCode = 'US';
					this.changeEmailObj.accessToken = this.accessToken;
					result = await this.$store.dispatch('USER_STORE/UPDATE_PROFILE', this.changeEmailObj);
					if (result.__type) {
						this.loading = false;
						msg = 'fail';
					} else {
						this.changeEmail = false;
						this.changeEmailObj = {};
						msg = 'success';
						this.changePasswordSuccessText = 'your email has been changed successfully';
						await this.$store.dispatch('USER_STORE/SIGN_OUT', { path: '/D2C/login' });
					}
				} else if (this.changePassword) {
					const $obj = Object.assign({}, this.changePasswordObj);
					delete $obj.confirmPassword;
					$obj.accessToken = this.accessToken;
					result = await this.$store.dispatch('USER_STORE/UPDATE_PASSWORD', $obj);
					if (result.__type) {
						this.loading = false;
						msg = 'fail';
					} else {
						this.changePassword = false;
						this.changePasswordObj = {};
						msg = 'success';
						this.changePasswordSuccessText = 'your password has been changed successfully';
					}
				} else {
					msg = 'success';
				}
				if (msg === 'success') {
					const self = this;
					self.$refs.change_password_success_message.textContent = this.changePasswordSuccessText;
					this.changePasswordSuccessText = '';
					const changeNamePayload = {
						action: 'UPDATE_PROFILE',
						customerProfileDetails: {
							firstName: this.profileInformation.firstName,
							lastName: this.profileInformation.lastName,
						},
					};
					await this.$store.dispatch('USER_STORE/UPDATE_PROFILE', changeNamePayload);
					if (this.isEurope) {
						const payload = {
							action: 'UPDATE_MARKETING_OFFERS',
							marketingOffers: this.enableMarketing,
						};
						await this.$store.dispatch('USER_STORE/UPDATE_PROFILE', payload);
					}
					this.getProfile();
					this.loading = false;
					this.editProfile();
				}
			} catch (exp) {
				if (this.changePassword) {
					this.$refs.update_details_validation_observer.reset();
					this.$refs.update_details_validation_observer.setErrors({
						previous_password: ['Current Password is Incorrect'],
					});
				}
				this.loading = false;
			}
		},
		backToInput(e) {
			if (e.keyCode === 9) {
				if (e.shiftKey) {
					// shiftkey will be undefined
				} else {
					e.preventDefault();
					const self = this;
					self.$nextTick().then(function () {
						self.$refs.profile_first_name.focusInput();
					});
				}
			}
		},
	},
};
</script>

<style lang="postcss">
.mk-tooltip:hover .icon-notification::before {
	color: #000;
}
</style>
